import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.*;

/**
 * Menu Principal de Sistema de Facturacion
 * 
 * @author G. Cherencio 
 * @version 1.0
 */
public class AppView {
    private JFrame fr = new JFrame("Sistema Facturacion");
    private JLabel lblMsg = new JLabel("Mensajes de la aplicacion");
    private JMenuBar mb = new JMenuBar();
    private JMenu mnuAr = new JMenu("Archivo");
    private JMenu mnuPr = new JMenu("Productos");
    private JMenu mnuCl = new JMenu("Clientes");
    private JMenu mnuFa = new JMenu("Facturacion");
    private JMenuItem mitArSalir = new JMenuItem("Salir");
    private JMenuItem mitPr1 = new JMenuItem("Productos");
    private JMenuItem mitCl1 = new JMenuItem("Clientes");
    private JMenuItem mitFa1 = new JMenuItem("Crear Factura");

    /**
     * Constructor for objects of class AppView
     */
    public AppView() {
        // armar Menu
        // agrego menu items al menu archivo
        mnuAr.add(mitArSalir);
        mnuPr.add(mitPr1);
        mnuCl.add(mitCl1);
        mnuFa.add(mitFa1);
        
        // agrego el menu archivo al menu bar
        mb.add(mnuAr);
        mb.add(mnuPr);
        mb.add(mnuCl);
        mb.add(mnuFa);
        
        // seteo el menu bar del JFrame
        fr.setJMenuBar(mb);
        
        // implementamos eventos de la GUI
        mitCl1.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                JPanel p = new JPanel();
                ClienteModel cm = new ClienteModel();
                JTable tbl = new JTable(cm);
                cm.setJTable(tbl);
                tbl.addKeyListener(cm);
                JScrollPane sp = new JScrollPane(tbl,
                    JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
                p.add(sp);
                fr.add(p,BorderLayout.CENTER);
                fr.invalidate(); // notificamos que la vista actual es invalida!
                fr.validate(); // valide la vista actual!
            }
        });
        
        // seleccionamos un Layout Manager
        fr.setLayout(new BorderLayout());
        fr.add(lblMsg,BorderLayout.SOUTH);
        fr.setSize(600,600);
        fr.setLocationRelativeTo(null);
        fr.setVisible(true);
        if ( !Util.loginOk ) {
            JOptionPane.showMessageDialog(fr, "Debe Estar Registrado para Usar esta pantalla", "Sistema Facturacion - Error", JOptionPane.ERROR_MESSAGE);
            System.exit(0);
        }
        
    }
    
    public static void main(String[] arg) {
        new AppView();
    }

}
